#include "jabber.h"



void deliver_login(char *user, char *pass, char *nick)
{
	char *buff = NULL;

	DBUG("Delivering Login information for",user)
	buff = strgrow(buff,"<login><user>",1,0);
	buff = strgrow(buff,user,1,0);
	buff = strgrow(buff,"</user><pass>",1,0);
	buff = strgrow(buff,pass,1,0);
	buff = strgrow(buff,"</pass><nick>",1,0);
	buff = strgrow(buff,nick,1,0);
	buff = strgrow(buff,"</nick></login>",1,0);
	etc.server->packets = packet_add(etc.server->packets,buff,"");
	free(buff);
}

void deliver_status(char *type, char *say)
{
	char *buff = NULL;

	DBUG("Delivering Status type",type)
	buff = strgrow(buff,"<status type=\"",1,0);
	buff = strgrow(buff,type,1,0);
	buff = strgrow(buff,"\"><say>",1,0);
	buff = strgrow(buff,say,1,0);
	buff = strgrow(buff,"</say></status>",1,0);
	etc.server->packets = packet_add(etc.server->packets,buff,"");
	free(buff);
}

void deliver_add(char *id)
{
	char *buff = NULL;

	DBUG("Delivering Roster Add for",id)
	buff = strgrow(buff,"<roster><add group=\"all\">",1,0);
	buff = strgrow(buff,id,1,0);
	buff = strgrow(buff,"</add></roster>",1,0);
	etc.server->packets = packet_add(etc.server->packets,buff,"");
	free(buff);
}

void deliver_who()
{
	DBUG("Delivering Roster Get","")
	etc.server->packets = packet_add(etc.server->packets,"<roster><get group=\"all\"/></roster>","");
}

void deliver_connection()
{
	char *buff = NULL;

	DBUG("Delivering Connection information","")
	buff = strgrow(buff,"<?xml version=\"1.0\"?><jabber version=\"",1,0);
	buff = strgrow(buff,APPSIG,1,0);
	buff = strgrow(buff,"\" protocol=\"",1,0);
	buff = strgrow(buff,PROTOCOL,1,0);
	buff = strgrow(buff,"\">",1,0);
	etc.server->packets = packet_add(etc.server->packets,buff,"");
	free(buff);
}

void deliver_message(	char *to_user,
			char *to_nick,
			char *subject,
			char *say,
			char *thread,
			char *ext,
			int priority)
{
	xpt *parent, *x;
	char intbuff[20], *str;
	jpair *par;

	parent = xpt_new_tag(NULL, "message", NULL);

	x = xpt_new_tag(parent, "to", NULL);
	xpt_new_cdata(x, to_user);
	if(to_nick != NULL)
		x->attributes = jpair_new(x->attributes, "nick", to_nick, 0);

	if(subject != NULL)
	{
		x = xpt_new_tag(parent, "subject", NULL);
		xpt_new_cdata(x, subject);
	}

	if(say != NULL)
	{
		x = xpt_new_tag(parent, "say", NULL);
		xpt_new_cdata(x, say);
	}

	if(thread != NULL)
	{
		x = xpt_new_tag(parent, "thread", NULL);
		xpt_new_cdata(x, thread);
	}

	if(ext != NULL)
	{
		x = xpt_new_tag(parent, "ext", NULL);
		xpt_new_cdata(x, ext);
	}

	if(priority != 0)
	{
		x = xpt_new_tag(parent, "priority", NULL);
		sprintf(intbuff,"%d",priority);
		xpt_new_cdata(x, intbuff);
	}

	str = xpt2str(parent);
	etc.server->packets = packet_add(etc.server->packets,str,"");
	free(str);
}

