#include "etherx.h"

void config_init()
{
	char *config = DEFAULT_CONFIG;
	xpt *xpt, *next;
	char *buf = NULL;
	char myname[MAXHOSTNAMELEN + 1];
	int f;

	if(jpair_getval(etc.arg,"-c") != NULL)
		config = jpair_getval(etc.arg,"-c");

	DBG_VAL("config",config)

	f = open(config,O_RDONLY);
	if(f < 0)
	{
		ERROR("main","Failed reading configuration file!");
	}else{
		xpt = xpt_file(config);

		if(xpt != NULL)
		{
			next = xpt->children;
			while(next != NULL)
			{
				if(next->type == XPT_TAG)
				{
					if(strcmp(next->name,"config") == 0)
					{
						etc.vars = xpt2jpair(next->children);
					}else{
						buf = NULL;
						while(next->children != NULL)
						{
							buf = strgrow(buf,xpt2str(next->children),1,1);
							next->children = next->children->next;
						}
						etc.transport_config = jpair_new(etc.transport_config, next->name, buf, 0);
						free(buf);
					}
				}
				next = next->next;
			}
		}else{
			ERROR("main","Configuration parsing failed!");
		}
	}

	if(jpair_get(etc.vars, "local") == NULL)
		etc.vars = jpair_new(etc.vars, "local", DEFAULT_LOCAL, 0);
	if(jpair_get(etc.vars, "log") == NULL)
		etc.vars = jpair_new(etc.vars, "log", DEFAULT_LOG, 0);
	if(jpair_get(etc.vars, "listen") == NULL)
	{
		gethostname(myname,MAXHOSTNAMELEN);
		etc.vars = jpair_new(etc.vars, "listen", myname, 0);
	}
	
}

void config_help()
{
	char *str;

	/* need to print right version, PACKAGE or whatever */
	printf("etherx version 0.6DR\n");
	printf("Usage:\n");
	printf("\t-D enable debugging info to STDOUT\n");
	printf("\t-c location of main configuration file\n");
	printf("\t-? this screen\n");
}
