<etherx>

This config file is just an example, please modify to fit your needs... only
recognized tags are processed, so you can type anywhere outside of them and 
not hurt anything.


This is the main section used by etherx for internal configuration.

  <config>

	By default etherx will listen on the main IP determined via "hostname".
	This can be used to change the default IP or listen on multiple IP's.
	<!--
		<listen>198.45.23.4</listen>
	-->

	Set this to specify a different location other than (installdir)/logs/etherx.log
	<!--
		<log>/tmp/jabber.log</log>
	-->

  </config>


This section is passed on to the "jabber" transport when it connects, and is where
most of the configuration for Jabber will happen at.

  <jabber>

	Make sure to put your Internet addressable name inside the name tag, it is
	how your server will identify itself on the Internet.  The default name is your
	system's "hostname".  Put any secondary names your server might be addressed
	as in an alias tag.  These are the only names that would be valid in an ID after the @.
	<!--
		<name>jabber.org</name>
		<alias>JABBER</alias>
		<alias>localhost</alias>
	-->

	This will force the server to listen on only one IP.  By default it will
	listen on all IP's at port 5222.
	<!--
		<listen>198.45.23.4</listen>
	-->

	Location of error log, defaults to (installdir)/logs/error.log
	<!--
		<log>/usr/local/jabber/logs/error.log</log>
	-->

	Users are categorized into groups, and those groups need to know which
	modules are going to handle which functions for their users.  This tells
	the server which modules handle which parts for each group.
	<groups>
		<group id="testing">
			<roster>mod_mysql</roster>
			<messages>mod_file</messages>
			<info>mod_mysql</info>
		</group>
		<group id="test" default="mod_test"/>
		<group id="users" default="mod_basic"/>
	</groups>

	This is a special section where any modules added into the server can
	access special configuration for them.  Use this area to configure
	each module to do exactly what you want.
	<modules>

		The "group" module associates users with the group they belong in.
		Use this to manage which users are being placed in which group.
		<mod_group default="users">
			Groups are identified by tag name and their users are "@" delimited.
			<test>debug@debuguser@modtestuser</test>
		</mod_group>

		This module will handle the most basic functions for a user, 
		and stores their rosters and offline messages for them in
		a spool area on the filesystem.
		<mod_basic>
			VALID USERS are added to this module below, format: userid@password
			  <user>u@p</user>
			  <user>username@password</user>
			  <user>test@test</user>
			  <user>someone@asdf</user>
			Filesystem location for data storage(must be a valid writeable directory),
			defaults to (installdir)/var
			<!--
				<spool>/usr/local/jabber/var</spool>
			-->
		</mod_basic>

		This is just an example, mod_mysql is coming soon.
		<mod_mysql>
			<host>localhost</host>
			<db>jabbers</db>
			<user>jab</user>
			<pass>P0wCheez</pass>
		</mod_mysql>

	</modules>

  </jabber>


Just an example possibility:

  <icq>
	<server port='4000'>icq.mirabilis.com</server>
	<server port='4000'>icq1.mirabilis.com</server>
  </icq>


Just another example possibility, fed to the test perl script:

  <perl>
	This is a sample chunk that is passed to the perl script.
	<junk>asdfasdf</junk>
	Anything can be contained between the tags, it all gets passed to the transport.
  </perl>


</etherx>
