#include "etherx.h"

void logger(int level, char *from, char *message)
{
	static time_t t;
	static int log, checklog;
	char *tstr, *tmpctime;
	int check;

	/* initialize and open the logfile if configured to do so */
	if(checklog != 1)
	{
		log = -1;
		if(jpair_get(etc.vars, "log") != NULL)
		{
			checklog = 1;
			log = open(jpair_getval(etc.vars, "log"), O_WRONLY | O_CREAT | O_APPEND);
			if(log < 0)
				ERROR("main", "Unable to open log file!");
		}
	}

	/* log only at the level told to do so */
	if(level >= etc.debug)
	{
		time(&t);
		tstr = strgrow(NULL,"[",0,0);
		tmpctime = strdup(ctime(&t));
		tmpctime[strlen(tmpctime) - 1] = '\0';
		tstr = strgrow(tstr,tmpctime,1,1);
		tstr = strgrow(tstr,"] ",1,0);
		tstr = strgrow(tstr,from,1,0);
		tstr = strgrow(tstr," \"",1,0);
		if(message != NULL)
			tstr = strgrow(tstr,message,1,0);
		tstr = strgrow(tstr,"\"\n",1,0);

		/* if a logfile is configured and opened, put logs there unless were debugging */
		if(log >= 0 && etc.debug > SYSLOG_DEBUG)
		{
			check = write(log, tstr, strlen(tstr));
			if(check != strlen(tstr))
			{
				log = -1;
				ERROR("main", "Writing to log file failed!");
				syslog(level, from, message);
			}
		}else{
			printf("%s",tstr);
		}

		free(tstr);
	}
}

