#ifndef __COMMON_TYPES_H
#define __COMMON_TYPES_H

#include "threads.h"


/* simple linked list */
typedef struct jpair_struct
{
	char *key;
	char *val;
	int flag;
	struct jpair_struct *next;
} jpair;


/* tree structure to store parsed XML */
typedef struct xpt_struct
{
	int type;
	int status;
	char *name;
	char *value;
	jpair *attributes;
	struct xpt_struct *children;
	struct xpt_struct *next;
	struct xpt_struct *parent;
} xpt;


/* is used to parse XML, is the top/root/parent of the XML doc being parsed */
typedef struct
{
	int flag;
	char *name;
	jpair *attributes;
	xpt *packets;
	xpt *buff;
	XML_Parser parser;
} xptpool;


/* stores outgoing data waiting to be sent to a socket */
typedef struct packet_struct
{
	MUTEX lock;									
	char *data;
	char *error_to;
	int sent;
	struct packet_struct *next;
} packet;


/* linked list of sockets, stores connection-lifetime data */
typedef struct conn_struct
{
	MUTEX lock;
	int id;
	char *ver;
	char *name;
	int type;
	packet *packets;
	xptpool *xp;
	struct conn_struct *next;
} conn;


#endif /* __COMMON_TYPES_H */
