#ifndef __QUEUE_H
#define __QUEUE_H

#define QUEUE_VERSION "$Id: queue.h,v 1.1 1999/04/06 03:29:53 nkirsch Exp $"

#include "threads.h"

typedef struct queue_item_st {
	MUTEX wlock;
	MUTEX rlock;		
	void * data;	
	struct queue_item_st * next;
	struct queue_item_st * prev;	
} queue_item;

/* 

	Queue structure. Should provide basic functions of a queue, and multi-threaded handling.

*/

typedef struct {
	MUTEX wlock;
	MUTEX rlock;
	unsigned long count;
	unsigned long max;
	queue_item * items;	
} queue_st;

queue_st * queue_new (unsigned long max);
short queue_add (queue_st * queue, queue_item * item);
queue_item *  queue_top (queue_st * queue);
short queue_del (queue_st * queue, void * data);
short queue_free (queue_st * queue);


#endif 
