#ifndef __THREADS_H
#define __THREADS_H


#define THREADS_VERSION "$Id: threads.h,v 1.2 1999/03/06 21:10:25 nkirsch Exp $"

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#ifdef HAVE_LIBPTHREAD
# include <pthread.h>
#
# define THREAD 							pthread_t *
# define CREATETHREAD(t,x,y) 	pthread_create (t, NULL, x,y);
# define INITTHREAD(t)				t = (pthread_t *) malloc (sizeof(pthread_t));
# define FREETHREAD(t)				if (t != NULL)	free (t);
# 
# define MUTEX								pthread_mutex_t *
# define CREATEMUTEX(m)				m = (MUTEX) malloc(sizeof (pthread_mutex_t)); pthread_mutex_init (m, NULL);					
# define LOCKMUTEX(m)					pthread_mutex_lock (m);
# define UNLOCKMUTEX(m)				pthread_mutex_unlock(m);
# define FREEMUTEX(m)					pthread_mutex_destroy(m); if (m != NULL) free (m);
# 
#else
#
# define THREAD 							char	
# define CREATETHREAD(t,x,y) 	x(y);
# define INITTHREAD(t)				;
# define FREETHREAD(t)				;
#
#	define MUTEX								char	
# define CREATEMUTEX(m)				;
# define LOCKMUTEX(m)					;
# define UNLOCKMUTEX(m)				;
# define FREEMUTEX(m)					;	
#
#endif

#endif /* __THREADS_H */
