#include "jabber.h"

void config_init()
{
	if(jpair_get(etc.arg,"-local") != NULL)
		etc.vars = jpair_new(etc.vars, "local", jpair_getval(etc.arg,"-local"), 0);
	else
		etc.vars = jpair_new(etc.vars, "local", DEFAULT_ETHERX, 0);
	if(jpair_get(etc.arg,"-errorlog") != NULL)
		etc.vars = jpair_new(etc.vars, "errorlog", jpair_getval(etc.arg,"-errorlog"), 0);
	else
		etc.vars = jpair_new(etc.vars, "errorlog", DEFAULT_LOG, 0);
}


void config_handle(xpt *x)
{
	xpt *next;
	jpair *last, *j, *p;
	int s;
	conn *c;
	char *str;
	char myname[MAXHOSTNAMELEN + 1];
	
	j = xpt2jpair(x);
	/* append all the vars in the config section to etc.vars */
	if(j != NULL)
	{
		last = j;
		while(last->next != NULL)
			last = last->next;
		last->next = etc.vars;
		etc.vars = j;
	}

	next = x;
	while(next != NULL)
	{
		if(next->type == XPT_TAG && strcmp(next->name,"modules") == 0)
			modules_initialize(next->children);
		if(next->type == XPT_TAG && strcmp(next->name,"groups") == 0)
			etc.modconfig = next;
		next = next->next;
	}


	/* initialize any critical variables that weren't configured */
	if(jpair_get(etc.vars,"name") == NULL)
	{
		s = gethostname(myname,MAXHOSTNAMELEN);
		if(s >= 0)
			etc.vars = jpair_new(etc.vars,"name",myname,0);
	}

	DBG_MSG("Listening for Clients");

	s = make_netsocket(DEFAULT_PORT, jpair_getval(etc.vars, "listen"), 0);
	h_err(s, "creating network socket");
	h_err(listen(s, 5), "listening on network socket");
	c = conn_add(NULL, s);
	c->type = CONN_LISTEN;
	c->name = strdup("parent");
	etc.transport = conn_append(etc.transport, c); /* tricky way of adding it to the io loop w/o passing it back the right way */

	DBG_MSG("Sending Transport Aliases");

	p = etc.vars;
	str = NULL;
	while(p != NULL)
	{
		if(p->key != NULL && (strcmp(p->key, "alias") == 0 || strcmp(p->key,"name") == 0) )
			str = strgrow(str, make_tag_quick("alias",p->val),1,1);
		p = p->next;
	}
	etc.transport->packets = packet_add(etc.transport->packets, str, NULL);

	free(str);
}


void config_help()
{
	char *str;

	/* need to print right version, PACKAGE or whatever */
	printf("jabber transport version 0.6DR\n");
	printf("Usage:\n");
	printf("\t-D enable debugging info to STDOUT\n");
	printf("\t-? this screen\n");
}
