session *session_add(conn *c, char *id, char *user, char *group);
void session_del(session *s);
session *session_lookup(conn *c, char *id, char *user);
void session_print();
void free_session(session *s);

conn *dispatch(char *p, conn *c, int flag);
void handle_packet(conn *c, xpt *x);

void sig_die();
char *make_tag_quick(char *name, char *value);
int islocal(char *address);

void config_init();
void config_help();

char *modules_getgroup(char *id);
handler *modules_gethandler_id(int phase, char *id);
handler *modules_gethandler_group(int phase, char *group);
handler *modules_gethandler_user(int phase, char *user);

jpair *get_from(conn *c, xpt *x);
jpair *get_to(conn *c, xpt *x);

void transport_deliver(char *from_user, char *from_nick, char *to_user, char *to_nick, xpt *x);
void local_deliver(char *from, char *user, char *nick, conn *c, xpt *x);

void deliver_message(char *from_user, char *from_nick, char *to_user, char *to_nick, char *subject, char *say, char *thread, char *ext, int priority, char *type);

void deliver_roster(conn *c, char *user, char *nick, jpair *list);

void status_update(char *user, char *nick, char *to, int status, char *say, char *icon, char *ext, int priority);
void status_change(char *user, char *nick, int status, char *say, char *icon, char *ext, int priority);

char *create_packet(char *name, jpair *atts, char *body);

void logger(int level, char *from, char *message);

void transport_errormessage(xpt *x, xpt *xml);

