#include "jabber.h"

/* mod_group
The only point of this module is to process the configuration and
resolve user-ids to group-ids, just matching up one for one.

This is a only for simple uses.  This type of functionality is better
handled in a dbm or other database, not embedded in the main configuration.
*/


jpair *group_users = NULL;
char *group_default = NULL;

char *mod_group_resolve(char *user)
{
	/* Returns the "group" that the user belongs to, only if we "know" about this user */
	DBG_VAL("MOD_GROUP",user);
	if(jpair_get(group_users,user) == NULL)
		return strdup(group_default);
	else
		return jpair_getvalnew(group_users,user);
}

void mod_group_init(xpt *config)
{
	char *id, *at;
	xpt *next;
	jpair *j;

	DBG_MSG("mod_group: initalizing");

	/* finding <mod_group default="asdf"><asdf>asdf@asdf@asdf@asdf@asdf<asdf></mod_group> tag, decoding, storing */
	next = config;
	while(next != NULL)
	{
		/* loop till we find our section in the config named "groups" */
		if(next->type == XPT_TAG && strcmp(next->name,"mod_group") == 0)
		{
			group_default = jpair_getvalnew(next->attributes, "default");
			/* start a new loop within the groups tag */
			next = next->children;
			while(next != NULL)
			{
				/* every tag we hit is a new group declaration */
				if(next->type == XPT_TAG)
				{
					id = xpt2str_chain(next->children);
					while(id != NULL && strlen(id) > 0)
					{
						at = strstr(id, "@");
						if(at != NULL)
						{
							*at = '\0';
							++at;
						}
						group_users = jpair_new(group_users,id,next->name,0);
						id = at;
					}
				}
				next = next->next;
			}
			break;
		}
		next = next->next;
	}

	/* this is the only API phase we need */
	module_set_group("mod_group", mod_group_resolve);
}


