
extern conn *transport;

/*
 * Structure for list of current connected online sessions known
 */
typedef struct session_struct
{
	char *user; /* actual username */
	char *nick; /* nickname */
	conn *c;
	char *group;
	char *status_say;
	char *status_icon;
	char *status_ext;
	int status_flag;
	int status_priority;
	time_t *activity;
	time_t *start;
	struct session_struct *next;
	struct session_struct *lookup_next;
} session;

/*
 * Used to store module functions for certian groups
 */
typedef struct handler_struct
{
	char *name;
	char *(*h_group)(char *user);
	int (*h_auth)(char *user, char *pass);
	void (*h_log)(char *user, char *nick);
	int (*h_status_in)(char *to, char *user, char *nick, int type, char *say, char *icon, char *ext, int priority);
	jpair *(*h_status_out)(char *user, char *nick, int type, char *say, char *icon, char *ext, int priority);
	int (*h_message)(char *localuser, char *localnick, char *otheruser, char *othernick, char *subject, char *say, char *thread, char *ext, int priority, char *type);
	jpair *(*h_roster)(char *localuser, int type, char *group, char *user);
	int type;
	struct handler_struct *next;
} handler;

struct config
{
	jpair *arg;		/* static after startup */
	jpair *vars;		/* static after config pass */
	conn *transport;	/* static after startup */
	session *sessions;	/* dynamic */
	handler *handlers;	/* static after config pass */
	xpt *modconfig;		/* static after config pass */
	int debug;		/* static after startup */
};

extern struct config etc;
